	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
	include Kite\KiteH.inc
	include Kite\Builder.inc
	include Kite\Kitb.inc

.data?
Store	PGPSTORE ?

.code
	assume fs:nothing
_Alloc proc S1ze:ULONG
	mov eax,fs:[TEB.Peb]
	invoke RtlAllocateHeap, PEB.ProcessHeap[Eax], HEAP_ZERO_MEMORY, S1ze
	ret
_Alloc endp

_Free proc Base:PVOID
	mov eax,fs:[TEB.Peb]
	invoke RtlFreeHeap, PEB.ProcessHeap[Eax], 0, Base
	ret
_Free endp

_AllocForBuild proc S1ze:ULONG
Local Base:PVOID
	and Base,NULL
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE
	.if !Eax
		mov eax,Base
	.else
		xor eax,eax
	.endif
	ret
_AllocForBuild endp

TestIp proc C
L0:
	jz L1
	add eax,ecx
	dec ebx
	jmp L2
DWORD 12345
L1:
	inc ecx
	jnz L0
	ret
DWORD 56789
L2:
	Call L3
	dec ebx
	ret
DWORD 34567
L3:
	pop eax
	ret
TestIp endp

EP proc
	push 0
	push -1	; NL
	push offset TestIp
	push 8	; Portion
	push offset _Free
	push offset _Alloc
	%CKITE KID_KIT
	mov Store,eax
	.if Zero?
		Int 3
	.endif
	
	push TRUE	; Optimization.
	push offset _AllocForBuild
	push offset _Free
	push offset _Alloc
	push Store
	%CKITB KID_BUILD
	.if !Eax
		Int 3
	.endif
	ret
EP endp
end EP